package myfilter;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.naming.*;
import javax.annotation.*;
import javax.sql.DataSource;

@Resource(name="myDataSource4", mappedName="jdbc/__default", type=DataSource.class)
@Resources({ @Resource(name="myDataSource5", mappedName="jdbc/__default", type=DataSource.class),
             @Resource(name="jdbc/myDataSource6", mappedName="jdbc/__default", type=DataSource.class) })

public class MyFilter implements Filter {

    private @Resource (mappedName="jdbc/__default") DataSource ds1;
    private @Resource(name="myDataSource2", mappedName="jdbc/__default") DataSource ds2;
    private DataSource ds3;

    @Resource(name="jdbc/myDataSource3", mappedName="jdbc/__default")
    private void setDataSource(DataSource ds) {
        ds3 = ds;
    }

    public void init(FilterConfig filterConfig) throws ServletException {

        ServletContext sc = filterConfig.getServletContext();
        String mylog = "";
    
        try {

            int loginTimeout = ds1.getLoginTimeout();
            mylog = debug(sc, mylog, "ds1-login-timeout=", loginTimeout);

            loginTimeout = ds2.getLoginTimeout();
            mylog = debug(sc, mylog, ", ds2-login-timeout=", loginTimeout);

            loginTimeout = ds3.getLoginTimeout();
            mylog = debug(sc, mylog, ", ds3-login-timeout=", loginTimeout);

            InitialContext ic = new InitialContext();

            DataSource ds4 = (DataSource)
                ic.lookup("java:comp/env/myDataSource4");
            loginTimeout = ds4.getLoginTimeout();
            mylog = debug(sc, mylog, ", ds4-login-timeout=", loginTimeout);

            DataSource ds5 = (DataSource)
                ic.lookup("java:comp/env/myDataSource5");
            loginTimeout = ds5.getLoginTimeout();
            mylog = debug(sc, mylog, ", ds5-login-timeout=", loginTimeout);

            DataSource ds6 = (DataSource)
                ic.lookup("java:comp/env/jdbc/myDataSource6");
            loginTimeout = ds6.getLoginTimeout();
            mylog = debug(sc, mylog, ", ds6-login-timeout=", loginTimeout);

            sc.setAttribute("testlog", mylog);
            sc.setAttribute("success", new Object());

        } catch (Exception e) {
            throw new ServletException(e);
        }

    }

    private  String debug(ServletContext sc, String base, 
                          String str1, int int1) {
             String result = "";
             sc.log(str1 + int1);
             result = base + str1 + int1;
             return result;
    }

    public void doFilter (ServletRequest request,
                          ServletResponse response,
                          FilterChain chain)
            throws IOException, ServletException {
        HttpServletRequest req = (HttpServletRequest) request;
        System.out.println("doFilter: url="+ req.getRequestURL());

        chain.doFilter(request, response);
    }

    public void destroy() {
        // do nothing
    }
}
